﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;
using System.Web;
using System.Security.Permissions;
using UrlRouter.Web;
using System.Xml;

namespace UrlRouter.Configuration
{
    [ConfigurationCollection(typeof(RewriteSettings))]
    public sealed class RewriteSettingsCollection : ConfigurationElementCollection
    {
        private string currentRuleProvider = String.Empty;

        protected override ConfigurationElement CreateNewElement() 
        {
            return new RewriteSettings();
        }

        protected override object GetElementKey(ConfigurationElement element)
        {
            return ((RewriteSettings)element).Name;
        }

        public RewriteSettings this[int index]
        {
            get
            {
                return (RewriteSettings)base.BaseGet(index);
            }
            set
            {
                if (base.BaseGet(index) != null)
                {
                    base.BaseRemoveAt(index);
                }
                this.BaseAdd(index, value);
            }
        }


        new public RewriteSettings this[string key]
        {
            get
            {
                return (RewriteSettings)base.BaseGet(key);
            }
        }

    }
}
