﻿using System;
using System.Collections.Generic;
using System.Text;

namespace DBScript
{
    /// <summary>
    /// 组件配置
    /// </summary>
    public class DBScriptConfig
    {
        private bool _isDebug = false;
        private string _debugFilePath = "/Log";
        private Dictionary<string,DBConfigNode> _dbConfigs=new Dictionary<string,DBConfigNode>();

        public DBScriptConfig()
        {
        }
        /// <summary>
        /// 是否调试
        /// </summary>
        public bool IsDebug
        {
            set
            {
                _isDebug = value;
            }
            get
            {
                return _isDebug;
            }
        }
        /// <summary>
        /// 日志文件夹
        /// </summary>
        public string DebugFilePath
        {
            get
            {
                return _debugFilePath;
            }
            set
            {
                _debugFilePath = value;
            }
        }
        /// <summary>
        /// 数据库节点集合
        /// </summary>
        public Dictionary<string, DBConfigNode> DbConfigs
        {
            set
            {
                _dbConfigs = value;
            }
            get
            {
                return _dbConfigs;
            }
        }
    }
}
