using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;

namespace DBScript
{
    /// <summary>
    /// Copyright (C) 2009-2012 Xuzhibin
    /// ݷ(SQLServer)
    /// û޸ԼĿҪ
    /// Created On 2009-02-04
    /// </summary> 
    public class MsSQLProvider : ProviderBase
    {

        #region 캯
        public MsSQLProvider(DBScriptConfig dsConfig, bool distributed, bool rw_separate)
            : base(dsConfig, distributed, rw_separate)
        {
            LastInsert_ID_SQL = "select ident_current('{0}');";
            QueryBuilder = new MsSQLQuery();
            Params = new List<DBParam>();
        }
        #endregion

        #region ݿӹ
        /// <summary>
        /// ݿתͬݿ
        /// </summary>
        /// <param name="qty"></param>
        /// <returns></returns>
        private SqlConnection GetConnection(QueryType qty)
        {
            if (IsSwitch && !string.IsNullOrEmpty(CurConnName))
            {
                return new SqlConnection(DBConfigs[CurConnName].ConnectionString);
            }
            string cname = GetConnName(qty);
            //SqlDebug(string.Format("{0}:{1}:{2}", cname, CurConn.ConnectionString, DBConfigs[cname].ConnectionString));
            return new SqlConnection(DBConfigs[cname].ConnectionString);
        }
        
        #endregion ݿӹ    

        #region Select
        /// <summary>
        /// ҳ
        /// </summary>
        public override IDBBase Page(int index, int size)
        {
            int first = (index - 1) * size+1;
            int lengh = size;
            return LimitFirst(first).LimitLengh(lengh);
        }
        #endregion Select

        #region GetReader

        /// <summary>
        ///  GetReader
        /// </summary>
        public override IDataReader GetReader()
        {
            string strSql = QueryBuilder.ExportList();
            //SqlDebug(strSql);
            this.BeginTime = DateTime.Now;

            SqlConnection connection = GetConnection(QueryType.Read);
            SqlCommand cmd = new SqlCommand(strSql, connection);
            try
            {
                connection.Open();

                PrepareCommand(connection, cmd, strSql, Params);
                this.QueryStr = cmd.CommandText;
                SqlDataReader myReader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
                cmd.Parameters.Clear();

                SqlDebug(string.Format("\r\nSqlOperate:{0}\r\nTable:{1}\r\nConn:{2}\r\nCommandText:\r\n{3}\r\nParameters:\r\n{4}RunTime:{5}\r\n",
                    QueryType.Read.ToString(), QueryBuilder.Table, string.Format("{0}@{1}", GetConnName(QueryType.Read), connection.DataSource), this.QueryStr, ParamsDebug(Params), RunTime()));
                
                return myReader;
            }
            catch (System.Data.SqlClient.SqlException e)
            {
                SqlDebug(string.Format("\r\nSqlOperate:{0}\r\nTable:{1}\r\nConn:{2}\r\nException:\r\n{3}\r\nRunTime:{4}\r\n",
                        QueryType.Read.ToString(), QueryBuilder.Table, string.Format("{0}@{1}", GetConnName(QueryType.Read), connection.DataSource), e.ToString(), RunTime()));
            }
            finally
            {
                ReSet();
                //cmd.Dispose();
                //connection.Close();
            }
            return null;
        }
        #endregion GetReader

        #region ִSQL
        /// <summary>
        /// ִsql䲢ص
        /// </summary>
        /// <param name="sqlstr"></param>
        /// <returns></returns>
        public override object ExecuteScalar(QueryType qty)
        {
            string sqlstr = QueryBuilder.ExportSql();
            //Console.WriteLine(sqlstr);

            //
            if (IsBeginTran && qty != QueryType.Read)
            {
                TranList.Add(new TransactionItem() { TranSQL=sqlstr,TranParams=Params});
                ReSet();
                return null;
            }

            this.BeginTime = DateTime.Now;

            using (SqlConnection connection = GetConnection(qty))
            {
                using (SqlCommand cmd = new SqlCommand())
                {
                    try
                    {

                        PrepareCommand(connection, cmd, sqlstr, Params);
                        this.QueryStr = cmd.CommandText;
                        object obj = cmd.ExecuteScalar();
                        cmd.Parameters.Clear();

                        SqlDebug(string.Format("\r\nSqlOperate:{0}\r\nTable:{1}\r\nConn:{2}\r\nCommandText:\r\n{3}\r\nParameters:\r\n{4}RunTime:{5}\r\n",
                        qty.ToString(), QueryBuilder.Table, string.Format("{0}@{1}", GetConnName(qty), connection.DataSource), this.QueryStr, ParamsDebug(Params), RunTime()));
                        //ReSet();

                        if ((Object.Equals(obj, null)) || (Object.Equals(obj, System.DBNull.Value)))
                        {
                            return null;
                        }
                        else
                        {
                            return obj;
                        }
                    }
                    catch (System.Data.SqlClient.SqlException e)
                    {
                        SqlDebug(string.Format("\r\nSqlOperate:{0}\r\nTable:{1}\r\nConn:{2}\r\nException:\r\n{3}\r\nRunTime:{4}\r\n",
                        qty.ToString(), QueryBuilder.Table, string.Format("{0}@{1}", GetConnName(qty), connection.DataSource), e.ToString(), RunTime()));
                        //throw e;
                    }
                    finally
                    {
                        ReSet();
                    }
                }
                return null;
            }
        }
        /// <summary>
        /// ִsql䣬Ӱ
        /// </summary>
        /// <param name="sqlstr"></param>
        public override int ExecuteNonQuery(QueryType qty)
        {
            string sqlstr = QueryBuilder.ExportSql();
            //
            if (IsBeginTran && qty != QueryType.Read)
            {
                TranList.Add(new TransactionItem() { TranSQL = sqlstr, TranParams = Params }); ;
                ReSet();
                return 0;
            }

            this.BeginTime = DateTime.Now;

            using (SqlConnection connection = GetConnection(qty))
            {
                using (SqlCommand cmd = new SqlCommand())
                {
                    try
                    {
                        
                        PrepareCommand(connection, cmd, sqlstr, Params);
                        this.QueryStr = cmd.CommandText;
                        int rows = cmd.ExecuteNonQuery();
                        cmd.Parameters.Clear();

                        SqlDebug(string.Format("\r\nSqlOperate:{0}\r\nTable:{1}\r\nConn:{2}\r\nCommandText:\r\n{3}\r\nParameters:\r\n{4}RunTime:{5}\r\n",
                        qty.ToString(), QueryBuilder.Table, string.Format("{0}@{1}", GetConnName(qty), connection.DataSource), this.QueryStr, ParamsDebug(Params), RunTime()));
                        ReSet();

                        return rows;
                    }
                    catch (System.Data.SqlClient.SqlException e)
                    {
                        SqlDebug(string.Format("\r\nSqlOperate:{0}\r\nTable:{1}\r\nConn:{2}\r\nException:\r\n{3}\r\nRunTime:{4}\r\n",
                        qty.ToString(), QueryBuilder.Table, string.Format("{0}@{1}", GetConnName(qty), connection.DataSource), e.ToString(), RunTime()));
                    }
                }
                return 0;
            }

        }
        /// <summary>
        /// ִжSQL䣬ʵݿ񣬷Ӱ
        /// </summary>
        /// <param name="SQLStringList"></param>
        public override int ExecuteSqlTran(List<TransactionItem> tranList)
        {
            int count = 0;
            this.BeginTime = DateTime.Now;

            using (SqlConnection conn = GetConnection(QueryType.Transaction))
            {
                conn.Open();
                SqlDebug(string.Format("\r\nSqlOperate:{0}\r\nStartTime:{1}\r\nConn:{2}\r\n", "ʼ", DateTime.Now, string.Format("{0}@{1}", GetConnName(QueryType.Transaction), conn.DataSource)));
                using (SqlTransaction trans = conn.BeginTransaction())
                {
                    SqlCommand cmd = new SqlCommand();
                    try
                    {
                        //ѭ
                        foreach (TransactionItem myDE in tranList)
                        {
                            string cmdText = myDE.TranSQL;
                            List<DBParam> cmdParms = myDE.TranParams;
                            PrepareCommand(conn,cmd, cmdText, cmdParms);
                            this.QueryStr = cmd.CommandText;
                            cmd.Transaction = trans;
                            count += cmd.ExecuteNonQuery();
                            cmd.Parameters.Clear();

                            SqlDebug(string.Format("\r\nSqlOperate:{0}\r\nTable:{1}\r\nConn:{2}\r\nCommandText:\r\n{3}\r\nParameters:\r\n{4}RunTime:{5}\r\n",
                QueryType.Transaction.ToString(), QueryBuilder.Table, string.Format("{0}@{1}", GetConnName(QueryType.Transaction), conn.DataSource),this.QueryStr, ParamsDebug(cmdParms), RunTime()));
                        }
                        trans.Commit();
                    }
                    catch (Exception ex)
                    {
                        trans.Rollback();
                        SqlDebug(string.Format("\r\nSqlOperate:{0}\r\nConn:{1}\r\nCommandText:\r\n{2}\r\nStartTime:{3}\r\n",
                       "ݻع", string.Format("{0}@{1}", GetConnName(QueryType.Transaction), conn.DataSource), ex.ToString(), DateTime.Now));
                    }
                }
                SqlDebug(string.Format("\r\nSqlOperate:{0}\r\nStartTime:{1}\r\nConn:{2}\r\n", "", DateTime.Now, string.Format("{0}@{1}", GetConnName(QueryType.Transaction), conn.DataSource)));
                return count;
            }
        }
        #endregion 

        #region չ
        private void PrepareCommand(SqlConnection conn,SqlCommand cmd, string cmdText, List<DBParam> cmdParms)
        {
            //SqlDebug(string.Format("{0}\r\n",conn.ConnectionString));
            if (conn.State != ConnectionState.Open)
                conn.Open();
            cmd.Connection = conn;
            if (!string.IsNullOrEmpty(cmdText))
            {
                cmd.CommandText = cmdText;
                cmd.CommandType = CommandType.Text;//cmdType;
            }
            if (cmdParms != null)
            {
                foreach (DBParam parameter in cmdParms)
                {
                    if ((parameter.Direction == ParameterDirection.InputOutput || parameter.Direction == ParameterDirection.Input) &&
                        (parameter.Value == null))
                    {
                        parameter.Value = DBNull.Value;
                    }
                    cmd.Parameters.Add(new SqlParameter(parameter.ParameterName, parameter.Value));
                }
            }
        }

        #endregion

        #region 
        protected override void ReSet()
        {
            QueryBuilder = new MsSQLQuery();
            Params = new List<DBParam>();
            QueryStr = "";
        }
        #endregion 
    }

}