﻿using System;
using System.Collections.Generic;
using System.Text;
using eBlog.Entity;
using DBScript;
namespace eBlog.Service
{
   public class StatisticsService
   {
        /// <summary>
        /// 缓存统计
        /// </summary>
        private static Sites _statistics;

        /// <summary>
        /// lock
        /// </summary>
        private static object lockHelper = new object();

        static StatisticsService()
        {
            LoadStatistics();
        }

        /// <summary>
        /// 初始化
        /// </summary>
        private static void LoadStatistics()
        {
            if (_statistics == null)
            {
                lock (lockHelper)
                {
                    if (_statistics == null)
                    {
                        _statistics = GetStatistics();
                    }
                }
            }
        }

        /// <summary>
        /// 获取
        /// </summary>
        /// <returns></returns>
        public static Sites GetStatistics()
        {
            IDBBase dal = DBFactory.GetDbProvider();

            return dal.GetModel<Sites>(1);
        }

        /// <summary>
        /// 修改
        /// </summary>
        /// <returns></returns>
        public static bool UpdateStatistics()
        {
            IDBBase dal = DBFactory.GetDbProvider();
            return dal.Update<Sites>(_statistics);
        }

        /// <summary>
        /// 更新文章数
        /// </summary>
        /// <param name="addCount">增加数，可为负数</param>
        /// <returns></returns>
        public static bool UpdateStatisticsPostCount(int addCount)
        {
            _statistics.PostCount += addCount;
            return UpdateStatistics();
        }

        /// <summary>
        /// 更新评论数
        /// </summary>
        /// <param name="addCount">增加数，可为负数</param>
        /// <returns></returns>
        public static bool UpdateStatisticsCommentCount(int addCount)
        {
            _statistics.CommentCount += addCount;
            return UpdateStatistics();
        }
    }
}
