using System;
using System.Collections;
using System.Collections.Generic;
using System.Web.UI;
using System.Web.UI.WebControls;
using DBScript;
using eBlog.Common;
using eBlog.Entity;
using eBlog.Core;
using eBlog.Common.Security;
namespace eBlog.Web.Admin
{
    public partial class AdminManage : PageBase
    {
        readonly IDBBase dal = DBFactory.GetDbProvider();

		protected void Page_Load(object sender, EventArgs e)
		{


            PageValidate.CheckAdminLogin(this);

            if (!Page.IsPostBack)
            {
                switch (action)
                {
                    case "add":
                    case "edit":
                        edit.Visible = true;
                        list.Visible = false;
                        BindRoleSelect();
                        ShowInfo();
                        
                        break;
                    case "del":
                        delInfo();
                        break;
                    default:
                        edit.Visible = false;
                        list.Visible = true;
                        BindList();
                        break;
                }
            }
            



		}

		private void BindList()
        {
            int PageIndex;
            if (!int.TryParse(Request.Params["page"], out PageIndex)) { PageIndex = 1; }
            ArrayList attrs = dal.Page(PageIndex, PageSize).GetListAndCount<Entity.Admin>();
            List<Entity.Admin> lists = attrs[0] as List<Entity.Admin>;
            ListCount = (int)attrs[1];
            RPLIST.DataSource = lists;
            RPLIST.DataBind();
            PageNav.Text = Pager.PageInfo(ListCount, PageSize, PageIndex);
            
        }

        private void BindRoleSelect()   //޸ĺҳؼ ҪShowInfo()֮ǰ,ΪShowInfo()ҪÿؼĬֵ
        {
            List<AdminRole> lists = dal.GetList<AdminRole>();
            selRole_ID.Items.Add(new ListItem(" ѡ ", ""));
            if (lists.Count == 0) return;
            foreach (AdminRole model in lists)
            {
                selRole_ID.Items.Add(new ListItem(model.RoleName, model.ID.ToString())); //dropwoenlist 
            }

        }

					
		public void btnSave_Click(object sender, EventArgs e)
		{

            this.edit.Visible = true;
            BindRoleSelect();
            ArrayList strErrs = new ArrayList(); //Addʱ::ֿؼ

            if (this.txtLoginName.Text == "")
            {
                strErrs.Add("txtLoginName::Ϊգַ");
            }
            if (this.txtAdminName.Text == "")
            {
                strErrs.Add("txtAdminName::Ϊգַ");
            }

            if (this.txtPassWord.Text == "" && action == "add")
            {
                strErrs.Add("txtPassWord::Ϊգַ");
            }

            if (!PageValidate.IsNumber(Request.Form["selRole_ID"]))
            {
                strErrs.Add("selRole_ID::ѡȨ޹ɫ");
            }

            if (strErrs.Count > 0)
            {
                string[] arrayErrs = (string[])strErrs.ToArray(typeof(string));
                string strErr = string.Join("\\n", arrayErrs);
                //MessageBox.Show(this,strErr);
                ErrCodeStr.Value = strErr;
                return;
            }

            string LoginName = this.txtLoginName.Text;
            string AdminName = this.txtAdminName.Text;

            string PassWord = this.txtPassWord.Text;

            int Role_ID = int.Parse(Request.Form["selRole_ID"]);

            if (id > 0 && action == "edit")
            {
                Entity.Admin model = dal.GetModel<Entity.Admin>(id); //Ϊ˲Ǹ,ȶڵٰ

                model.LoginName = LoginName;
                model.AdminName = AdminName;

                if (!String.IsNullOrEmpty(PassWord)) 
                {
                    model.PassWord = MD5.Encrypt(PassWord);
                }
                
                model.RoleID = Role_ID;
                model.TableName = "Admin";
                dal.Update<Entity.Admin>(model);

                //MessageBox.ShowAndRedirect(this, "   !", Referrer.Value);
                return;
            }
            else
            {

                Entity.Admin model = new Entity.Admin();

                model.LoginName = LoginName;
                model.AdminName = AdminName;
                model.LastLoginTime = TimeParser.GetNowTime();
                model.LastLoginIP = Request.UserHostAddress;
                model.LoginCount = 0;
                model.PassWord = MD5.Encrypt(PassWord);
                model.RoleID = Role_ID;

                if (dal.From<Entity.Admin>().Where("LoginName='" + model.LoginName + "'").Exists())
                {
                    ErrCodeStr.Value = "txtLoginName::¼Ѿڣ";
                    return;
                }

                model.TableName = "Admin";

                Response.Redirect(Request.Url.AbsolutePath + "#" + dal.Add<Entity.Admin>(model).ToString()); //صǰUriԵַ
                return;
                
            }
			
		}

		private void ShowInfo()
		{
            try { this.Referrer.Value = Request.UrlReferrer.PathAndQuery; }
            catch { }

            if (id > 0 && action == "edit")
            {
                Entity.Admin model = dal.GetModel<Entity.Admin>(id);

                this.txtLoginName.Text = model.LoginName;
                this.txtAdminName.Text = model.AdminName;
                this.txtPassWord.Text = model.PassWord;
                //this.selRole_ID.=model.Role_ID.ToString();


                try
                {
                    selRole_ID.Items.FindByValue(model.RoleID.ToString()).Selected = true;
                }
                catch { }

                this.btnSave.Text = " ";
            }

		}

		private void delInfo()
		{
           // dal.Delete("Admin", "id", id);
			Response.Redirect(Request.Url.AbsolutePath); //صǰUriԵַ
			return;
		}


        public static string getAdminName(string idstr)
        {
            if (String.IsNullOrEmpty(idstr))
            {
                return "";
            }

            IDBBase dal = DBFactory.GetDbProvider(); //ʼݹ
            int id = int.Parse(idstr);

            return dal.From("Admin", "").Select("adminname").Where("id=" + id).GetString();

        }

        public static string getAdminLoginName(string idstr)
        {
            IDBBase dal = DBFactory.GetDbProvider(); //ʼݹ
            int id = int.Parse(idstr);

            return dal.From("Admin", "").Select("loginname").Where("id=" + id).GetString();

        }

        public static int getAdminRoleID(string idstr)
        {
            IDBBase dal = DBFactory.GetDbProvider(); //ʼݹ
            int id = int.Parse(idstr);

            return dal.From("Admin", "").Select("Role_ID").Where("id=" + id).GetInt();

        }

    }
}

