using System;
using System.Collections;
using System.Collections.Generic;
using System.Web.UI;
using DBScript;
using eBlog.Common;
using eBlog.Entity;
using eBlog.Core;
using System.Web.UI.HtmlControls;

namespace eBlog.Web.Admin
{
    public partial class AdminRoleManage : PageBase
    {
        readonly IDBBase dal = DBFactory.GetDbProvider(); //ʼݹ

		protected void Page_Load(object sender, EventArgs e)
		{


            PageValidate.CheckAdminLogin(this);

            if (!Page.IsPostBack)
            {
                switch (action)
                {
                    case "add":
                    case "edit":
                        edit.Visible = true;
                        list.Visible = false;
                        ShowInfo();
                        break;
                    case "del":
                        delInfo();
                        break;
                    default:
                        edit.Visible = false;
                        list.Visible = true;
                        BindList();
                        break;
                }
            }

		}

		private void BindList()
        {
            int PageIndex;
            if (!int.TryParse(Request.Params["page"], out PageIndex)) { PageIndex = 1; }

            ArrayList attrs = dal.Page(PageIndex, PageSize).GetListAndCount<AdminRole>();

            List<AdminRole> lists = attrs[0] as List<AdminRole>;
            ListCount = (int)attrs[1];
            RPLIST.DataSource = lists;
            RPLIST.DataBind();
            PageNav.Text = Pager.PageInfo(ListCount, PageSize, PageIndex); 
        }

					
		public void btnSave_Click(object sender, EventArgs e)
		{
			ArrayList strErrs = new ArrayList(); //Addʱ::ֿؼ
			this.edit.Visible = true;
			if(this.txtRoleName.Text =="")
			{
				strErrs.Add("txtRoleName::Ϊգַ"); 
			}

			if (strErrs.Count > 0) 
			{
				string[] arrayErrs = (string[])strErrs.ToArray(typeof(string));
				string strErr = string.Join("\\n", arrayErrs); 
				//MessageBox.Show(this,strErr);
				ErrCodeStr.Value = strErr;
				return;
			}

			string RoleName=this.txtRoleName.Text;
            string CustomUrl = this.txtCustomUrl.Text;

            bool isSuper = this.isSuper1.Checked ? true : false;

            string RightsUrl = getCheckBox(); //ѡȨ鷵ֵ


			if (action == "edit" && id > 0)
			{
				AdminRole model = dal.GetModel<AdminRole>(id); //Ϊ˲Ǹ,ȶڵٰ

				model.RoleName=RoleName;
				model.RightsUrl=RightsUrl;
                model.CustomUrl = CustomUrl;
                model.isSuper = isSuper;


				dal.Update<AdminRole>(model);
				//MessageBox.ShowAndRedirect(this, "   !", Referrer.Value);
				return;
			}
			else
			{
				AdminRole model = new AdminRole();  //,׼µʵ

				model.RoleName=RoleName;
				model.RightsUrl=RightsUrl;
                model.CustomUrl = CustomUrl;
                model.isSuper = isSuper;


				Response.Redirect(Request.Url.AbsolutePath + "#" + dal.Add<AdminRole>(model).ToString()); //ADD صǰUriԵַ
				return;
			}
			
		}

		private void ShowInfo()
		{
			try { this.Referrer.Value = Request.UrlReferrer.PathAndQuery; }  catch { }
			if (id > 0 && action == "edit")
			{
				AdminRole model = dal.GetModel<AdminRole>(id);

				this.lblID.Text=model.ID.ToString();
				this.txtRoleName.Text=model.RoleName;
                this.txtCustomUrl.Text = model.CustomUrl;


                if (model.isSuper)
                {
                    isSuper1.Checked = true;
                    isSuper2.Checked = false;
                }
                else
                {
                    isSuper2.Checked = true;
                    isSuper1.Checked = false;
                }
            

				this.btnSave.Text = " ";


                //ȨCheckBox
                string[] s_purview = model.RightsUrl.Split('|');
                foreach (Control control in edit.Controls)
                {
                    if (control is HtmlInputCheckBox)
                    {
                        for (int i = 0; i < s_purview.Length; i++)
                        {
                            if (s_purview[i] == ((HtmlInputCheckBox)control).Value)
                            {
                                ((HtmlInputCheckBox)control).Checked = true;
                                break;
                            }
                        }
                    }
                }

			}

		}




		private void delInfo()
		{
            if (!dal.From("Admin", "id").Where("Role_ID=" + id).Exists())
            {
               // dal.Delete("AdminRole", "id", id);
                Response.Redirect(Request.Url.AbsolutePath); //صǰUriԵַ
                return;
            }
            else
            {
                //MessageBox.ShowAndRedirect(this, "ɫʹ,ɾ!", Request.Url.AbsolutePath);
                return;
            
            }
		}


        /// <summary>
        /// øҳеCheckBoxֵ
        /// </summary>
        /// <returns></returns>
        protected string getCheckBox()
        {
            string str = null;
            foreach (Control contorl in edit.Controls)
            {
                if (contorl is HtmlInputCheckBox && ((HtmlInputCheckBox)contorl).Checked)
                {
                    str += ((HtmlInputCheckBox)contorl).Value + "|";
                }
            }
            if (str != null)
                return str.Substring(0, str.Length - 1);
            else
                return "";
        }

		//private void BindRoleSelect()   //޸ĺҳؼ ҪShowInfo()֮ǰ,ΪShowInfo()ҪÿؼĬֵ
        //{
        //    List<vt_AdminRole> lists = dal.GetList<vt_AdminRole>();
        //    selRole_ID.Items.Add(new ListItem(" ѡ ", ""));
        //    if (lists.Count == 0) return;
        //    foreach (vt_AdminRole model in lists)
        //    {
        //        selRole_ID.Items.Add(new ListItem(model.RoleName, model.ID.ToString())); //dropwoenlist 
        //    }
        //}


        public static string getAdminRoleName(int roleID)
        {
            IDBBase dal = DBFactory.GetDbProvider(); //ʼݹ

            return dal.From("adminrole", "").Select("RoleName").Where("id=" + roleID).GetString();

        }

    }
}

