﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Web.UI;
using System.Web.UI.WebControls;
using DBScript;
using eBlog.Common;
using eBlog.Core;
using eBlog.Entity;

namespace eBlog.Web.Admin
{
    public partial class UserManage : PageBase
    {       
        
		IDBBase dal = DBFactory.GetDbProvider(); //初始化数据工厂

		protected void Page_Load(object sender, EventArgs e)
		{

            PageValidate.CheckAdminLogin(this);
			//if (!PageValidate.CheckAdminRole(this, true)) { return; }

            if (!Page.IsPostBack)
            {
                switch (action)
                {
                    case "add":
                    case "edit":
                        edit.Visible = true;
                        list.Visible = false;
                        ShowInfo();
                        break;
                    case "del":
                        delInfo();
                        break;
					case "show":
                        edit.Visible = false;
                        list.Visible = false;
                        //show.Visible = true;
                        break;
                    default:
                        edit.Visible = false;
                        list.Visible = true;
                        BindList();
                        break;
                }
            }
			else
            {
                if (action == "del")
                    delInfo();
            }

		}

		private void BindList()
        {
            int PageIndex;
            if (!int.TryParse(Request.Params["page"], out PageIndex)) { PageIndex = 1; }

            ArrayList attrs = dal.Page(PageIndex, PageSize).GetListAndCount<User>();

            List<User> lists = attrs[0] as List<User>;
            ListCount = (int)attrs[1];
            RPLIST.DataSource = lists;
            RPLIST.DataBind();
            PageNav.Text = Pager.PageInfo(ListCount, PageSize, PageIndex); 
        }

					
		public void btnSave_Click(object sender, EventArgs e)
		{
			ArrayList strErrs = new ArrayList(); //Add时候必须用::分开控件名
			this.edit.Visible = true;
			if(this.txtLoginName.Text =="")
			{
				strErrs.Add("txtLoginName::LoginName不能为空，请输入字符！"); 
			}
			if(this.txtEmail.Text =="")
			{
				strErrs.Add("txtEmail::Email不能为空，请输入字符！"); 
			}
			
			if(!PageValidate.IsDateTime(txtCreateTime.Text))
			{
				strErrs.Add("txtCreateTime::CreateTime必须输入时间格式2010-12-31，请选择日期时间！"); 
			}
			if(!PageValidate.IsDateTime(txtLastLoginTime.Text))
			{
				strErrs.Add("txtLastLoginTime::LastLoginTime必须输入时间格式2010-12-31，请选择日期时间！"); 
			}
			
			
			if(this.txtRealName.Text =="")
			{
				strErrs.Add("txtRealName::RealName不能为空，请输入字符！"); 
			}
			if(this.txtAddress.Text =="")
			{
				strErrs.Add("txtAddress::Address不能为空，请输入字符！"); 
			}
			if(this.txtUrl.Text =="")
			{
				strErrs.Add("txtUrl::Url不能为空，请输入字符！"); 
			}
			if (strErrs.Count > 0) 
			{
				string[] arrayErrs = (string[])strErrs.ToArray(typeof(string));
				string strErr = string.Join("\\n", arrayErrs); 
				//MessageBox.Show(this,strErr);
				ErrCodeStr.Value = strErr;
				return;
			}

			string LoginName=this.txtLoginName.Text;
			string Email=this.txtEmail.Text;
		
			DateTime CreateTime=DateTime.Parse(this.txtCreateTime.Text);
			DateTime LastLoginTime=DateTime.Parse(this.txtLastLoginTime.Text);
		
			string RealName=this.txtRealName.Text;
			string Address=this.txtAddress.Text;
			string Url=this.txtUrl.Text;
	    	bool Enable=this.chkEnable.Checked;
			


			if (action == "edit" && id > 0)
			{
				User model = dal.GetModel<User>(id); //为了不覆盖更新,先读出存在的数据再按需填充数据

				model.LoginName=LoginName;
				model.Email=Email;
			
				model.CreateTime=CreateTime;
				model.LastLoginTime=LastLoginTime;
			
				model.RealName=RealName;
				model.Address=Address;
				model.Url=Url;
				dal.Update<User>(model);
				//MessageBox.ShowAndRedirect(this, "修 改 完 成!", Referrer.Value);
				return;
			}
			else
			{
				User model = new User();  //添加数据,准备新的实体

				model.LoginName=LoginName;
				model.Email=Email;
				
				model.CreateTime=CreateTime;
				model.LastLoginTime=LastLoginTime;
				
				model.RealName=RealName;
				model.Address=Address;
				model.Url=Url;
				
				model.Enable=Enable;
			


				Response.Redirect(Request.Url.AbsolutePath + "#" + dal.Add<User>(model).ToString()); //ADD并 返回当前Uri绝对地址不带参数
				return;
			}
			
		}

		private void ShowInfo()
		{
			try { this.Referrer.Value = Request.UrlReferrer.PathAndQuery; }  catch { }
			if (id > 0 && action == "edit")
			{
				User model = dal.GetModel<User>(id);

				this.lblID.Text=model.ID.ToString();
				this.txtLoginName.Text=model.LoginName;
				this.txtEmail.Text=model.Email;
		
				this.txtCreateTime.Text=model.CreateTime.ToString();
				this.txtLastLoginTime.Text=model.LastLoginTime.ToString();
			
				this.txtRealName.Text=model.RealName;
				this.txtAddress.Text=model.Address;
				this.txtUrl.Text=model.Url;
		
				this.chkEnable.Checked=model.Enable;
			
				this.btnSave.Text = "编 辑";
			}

		}




		private void delInfo()
		{
			string ids = PageValidate.Form("checkallid");
            if (!String.IsNullOrEmpty(ids))
            {
                //dal.From("User", "").Where("id in (@ids)").SetString("ids", ids).Delete();
                dal.From("User", "").Where("id in ("+ids+")").Delete();
            }
            else
			{
			    dal.Delete<User>(id);
			}

			Response.Redirect(Request.Url.AbsolutePath); //返回当前Uri绝对地址不带参数
			return;
		}


    }
}

